# CHANGELOG

## v1.0.2 (2024-08-24)

### Fix

* fix: switch to github trusted publishing to fix ci (#53) ([`dfaf168`](https://github.com/bdraco/ulid-transform/commit/dfaf1687c32d07ea8e92358a9f1cb8275a6f6b54))

## v1.0.1 (2024-08-24)

### Fix

* fix: bump ci to run on python 3.11 (#52) ([`857e9b8`](https://github.com/bdraco/ulid-transform/commit/857e9b80787e20565d41029dac5f655b1f152672))

## v1.0.0 (2024-08-24)

### Breaking

* feat!: drop python 3.10 support (#51) ([`b93b779`](https://github.com/bdraco/ulid-transform/commit/b93b77957945c38f334912d64e7c7aa4137863e3))

## v0.14.0 (2024-08-24)

### Chore

* chore(pre-commit.ci): pre-commit autoupdate (#49)

updates:
- [github.com/astral-sh/ruff-pre-commit: v0.5.7 → v0.6.1](https://github.com/astral-sh/ruff-pre-commit/compare/v0.5.7...v0.6.1)

Co-authored-by: pre-commit-ci[bot] &lt;66853113+pre-commit-ci[bot]@users.noreply.github.com&gt; ([`3946e2f`](https://github.com/bdraco/ulid-transform/commit/3946e2ff626e3034685cf6b483aa6c204dc8bca6))

* chore(pre-commit.ci): pre-commit autoupdate (#48)

Co-authored-by: pre-commit-ci[bot] &lt;66853113+pre-commit-ci[bot]@users.noreply.github.com&gt; ([`48fbe45`](https://github.com/bdraco/ulid-transform/commit/48fbe45e65c5a249a7c1eea3b8519b69f4f71020))

* chore(pre-commit.ci): pre-commit autoupdate (#47)

updates:
- [github.com/astral-sh/ruff-pre-commit: v0.5.5 → v0.5.6](https://github.com/astral-sh/ruff-pre-commit/compare/v0.5.5...v0.5.6)
- [github.com/PyCQA/flake8: 7.1.0 → 7.1.1](https://github.com/PyCQA/flake8/compare/7.1.0...7.1.1)
- [github.com/pre-commit/mirrors-mypy: v1.11.0 → v1.11.1](https://github.com/pre-commit/mirrors-mypy/compare/v1.11.0...v1.11.1)

Co-authored-by: pre-commit-ci[bot] &lt;66853113+pre-commit-ci[bot]@users.noreply.github.com&gt; ([`3192c1c`](https://github.com/bdraco/ulid-transform/commit/3192c1cdf5a9c22a3d63193ee21ca133bc95006a))

### Feature

* feat: python 3.13 support (#50) ([`c50e08a`](https://github.com/bdraco/ulid-transform/commit/c50e08ac1c019ee8a3313780a7fd180f60e4db3f))

## v0.13.1 (2024-07-30)

### Chore

* chore(pre-commit.ci): pre-commit autoupdate (#45)

updates:
- [github.com/asottile/pyupgrade: v3.16.0 → v3.17.0](https://github.com/asottile/pyupgrade/compare/v3.16.0...v3.17.0)
- [github.com/astral-sh/ruff-pre-commit: v0.5.4 → v0.5.5](https://github.com/astral-sh/ruff-pre-commit/compare/v0.5.4...v0.5.5)

Co-authored-by: pre-commit-ci[bot] &lt;66853113+pre-commit-ci[bot]@users.noreply.github.com&gt; ([`d4b3890`](https://github.com/bdraco/ulid-transform/commit/d4b3890a78a3145c84d0a0f72d80e6face310922))

### Fix

* fix: add pyi stubs for cython implementation (#46) ([`dedaa87`](https://github.com/bdraco/ulid-transform/commit/dedaa87d9e5df4ed037bb0a95c971a6e6e376439))

## v0.13.0 (2024-07-29)

### Chore

* chore: CI fixes (version upgrades, repair extension build in some configs) (#44) ([`de99c22`](https://github.com/bdraco/ulid-transform/commit/de99c22c1a0595fb0068d1abc3ffac157b11f3d4))

### Feature

* feat: improve performance of C implementation (#43) ([`f07d838`](https://github.com/bdraco/ulid-transform/commit/f07d838169743c4e68f344a04b6541a6a8fee239))

## v0.12.0 (2024-07-26)

### Feature

* feat: improve testability, keep implementations in sync (#40)

* chore: ignore Cython annotation file

* fix: synchronize c/py implementations

Each implementation now exposes the same public methods,
and their docstrings and signatures are equivalent.

* chore: remove hand-decoding ULID timestamp from test code

* feat: test C and Python implementations simultaneously

* chore: use new-style annotations in Cython too

They&#39;re exported as annotation strings anyway

* chore: add tests to make sure Python and C impls are in sync ([`975079d`](https://github.com/bdraco/ulid-transform/commit/975079d682ffb6039454d3c041867e0d14a9f646))

## v0.11.1 (2024-07-26)

### Chore

* chore: remove IDEA configuration from repository (#39) ([`1d95563`](https://github.com/bdraco/ulid-transform/commit/1d95563461026a7829b4e85a7f93efd71ed55080))

* chore: add benchmarking tests (#38) ([`456b967`](https://github.com/bdraco/ulid-transform/commit/456b967b457200f3001210fa527242f8a7d229b3))

### Fix

* fix: cython build, add a test to verify the Cython module is available (#41) ([`7187b35`](https://github.com/bdraco/ulid-transform/commit/7187b357b395b9c1716c8beaa5fc4db389fece18))

## v0.11.0 (2024-07-25)

### Feature

* feat: add fast ULID bytes functions (#37) ([`57b58ab`](https://github.com/bdraco/ulid-transform/commit/57b58ab269dcb97dbc905925861c3a25daf7e114))

## v0.10.2 (2024-07-25)

### Chore

* chore(pre-commit.ci): pre-commit autoupdate (#35)

Co-authored-by: pre-commit-ci[bot] &lt;66853113+pre-commit-ci[bot]@users.noreply.github.com&gt; ([`bdbb9c5`](https://github.com/bdraco/ulid-transform/commit/bdbb9c58f6d55209416eb7812e31669e14f39171))

* chore(pre-commit.ci): pre-commit autoupdate (#34)

Co-authored-by: pre-commit-ci[bot] &lt;66853113+pre-commit-ci[bot]@users.noreply.github.com&gt; ([`a27b5b0`](https://github.com/bdraco/ulid-transform/commit/a27b5b0ae2b07f1d5990ea4c04788472e921d415))

* chore(pre-commit.ci): pre-commit autoupdate (#33)

updates:
- [github.com/astral-sh/ruff-pre-commit: v0.5.0 → v0.5.1](https://github.com/astral-sh/ruff-pre-commit/compare/v0.5.0...v0.5.1)

Co-authored-by: pre-commit-ci[bot] &lt;66853113+pre-commit-ci[bot]@users.noreply.github.com&gt; ([`4d75f52`](https://github.com/bdraco/ulid-transform/commit/4d75f52e205ec7a4daf3cc1b23769867b9b65996))

### Fix

* fix: fix error message in Cython `bytes_to_ulid` (#36) ([`d8b5462`](https://github.com/bdraco/ulid-transform/commit/d8b54622d1445916f08b61ff3aad34e61bfbb986))

## v0.10.1 (2024-07-05)

### Fix

* fix: wheel builds (#32) ([`87b511e`](https://github.com/bdraco/ulid-transform/commit/87b511e1b00b8fa07ef7a18a5b5012e8df943441))

## v0.10.0 (2024-07-05)

### Chore

* chore: switch to ruff (#31) ([`98679ea`](https://github.com/bdraco/ulid-transform/commit/98679ea082591ae710188798b594e57c4f05f444))

* chore(pre-commit.ci): pre-commit autoupdate (#29)

updates:
- [github.com/pre-commit/mirrors-mypy: v1.10.0 → v1.10.1](https://github.com/pre-commit/mirrors-mypy/compare/v1.10.0...v1.10.1)

Co-authored-by: pre-commit-ci[bot] &lt;66853113+pre-commit-ci[bot]@users.noreply.github.com&gt; ([`72c43be`](https://github.com/bdraco/ulid-transform/commit/72c43be55a4597066d33d44a92ecb33dd2a5c806))

* chore(pre-commit.ci): pre-commit autoupdate (#28)

Co-authored-by: pre-commit-ci[bot] &lt;66853113+pre-commit-ci[bot]@users.noreply.github.com&gt; ([`63cc7f9`](https://github.com/bdraco/ulid-transform/commit/63cc7f9f596df98c59a2564a8749f7b999f1407b))

* chore: add more cover and benchmarks (#27) ([`822ea8c`](https://github.com/bdraco/ulid-transform/commit/822ea8c5e69b4a9652c19ae0172c16f8236634f5))

* chore: test on 32bit (#26) ([`5a62d31`](https://github.com/bdraco/ulid-transform/commit/5a62d31fbb75fd20aa386d44a576e939f665312d))

### Feature

* feat: add new fast or_none functions (#30) ([`4d1d1ee`](https://github.com/bdraco/ulid-transform/commit/4d1d1ee398f791bd35a64941d3eb838cf1ef705e))

## v0.9.0 (2023-10-18)

### Feature

* feat: build wheel with latest cpython release (#25) ([`8bc67fe`](https://github.com/bdraco/ulid-transform/commit/8bc67fe8f2c56a9aacdede63331afe6c54a1528d))

### Fix

* fix: reduce size of wheels by excluding generated .cpp files (#24) ([`29e0ff4`](https://github.com/bdraco/ulid-transform/commit/29e0ff474f729adea32c10a3d0adfc7801b5e892))

## v0.8.1 (2023-08-27)

### Chore

* chore: bump py3.12 to rc1 (#23) ([`e21accd`](https://github.com/bdraco/ulid-transform/commit/e21accd67406f20aca65e754643e282da39ada26))

### Fix

* fix: rebuild wheels with cython 3.0.2 (#22) ([`8d78432`](https://github.com/bdraco/ulid-transform/commit/8d78432cf81b1a2e5230dd434b50c21365686548))

## v0.8.0 (2023-07-24)

### Feature

* feat: initial cpython 3.12 support (#21) ([`7f7e8b9`](https://github.com/bdraco/ulid-transform/commit/7f7e8b90d3a7a529a58d00e66be8494a18476842))

## v0.7.2 (2023-05-01)

### Fix

* fix: ensure windows wheel work with older versions (#20) ([`8a440e3`](https://github.com/bdraco/ulid-transform/commit/8a440e3f818b3af8a694544755d55f1c221ada3a))

## v0.7.1 (2023-05-01)

### Fix

* fix: missing decode for _bytes_to_ulid (#19) ([`ddf6433`](https://github.com/bdraco/ulid-transform/commit/ddf6433554ca3d4fef6500b84e43adf475a794bb))

## v0.7.0 (2023-04-23)

### Feature

* feat: add a bytes_to_ulid cpp version (#18) ([`fa1c62c`](https://github.com/bdraco/ulid-transform/commit/fa1c62c97be608390a5e42de5712382ee8ec86e9))

## v0.6.3 (2023-04-10)

### Fix

* fix: additional 32bit time fixes (#17) ([`2f5f1be`](https://github.com/bdraco/ulid-transform/commit/2f5f1be3fe63bb63b57e158c32ab5e9d7ab16b9c))

## v0.6.2 (2023-04-09)

### Fix

* fix: apply 32bit cast for for random data (#16) ([`1e1d62a`](https://github.com/bdraco/ulid-transform/commit/1e1d62aa961178d6416e4ac82cc0634b06260ad4))

## v0.6.1 (2023-04-09)

### Chore

* chore: add test_non_uppercase_b32_data (#14) ([`06819d0`](https://github.com/bdraco/ulid-transform/commit/06819d058f2a754a39221027cafb98d0568c5b18))

### Fix

* fix: apply 32bit time fix (#15) ([`26347f0`](https://github.com/bdraco/ulid-transform/commit/26347f0067be94ba36607ea9b875b5d1354e6002))

## v0.6.0 (2023-04-06)

### Feature

* feat: reflect the invalid value when raising ValueError (#13) ([`6a022fb`](https://github.com/bdraco/ulid-transform/commit/6a022fb4084e3a007c469e6e2993ccb3621c4271))

## v0.5.1 (2023-03-22)

### Fix

* fix: specify python version to build wheels (#12) ([`9263de0`](https://github.com/bdraco/ulid-transform/commit/9263de0f70a4198cfcb2ba4a8f44440a7841e407))

## v0.5.0 (2023-03-22)

### Feature

* feat: wheels for macOS and Windows (#11)

Build wheels for macOS and Windows too ([`086852e`](https://github.com/bdraco/ulid-transform/commit/086852e57250994d0f3c9faedabf2df6aeb9e789))

## v0.4.2 (2023-03-13)

### Fix

* fix: ulid_now on 32bit (#10) ([`c8f7dd7`](https://github.com/bdraco/ulid-transform/commit/c8f7dd790f987ca4310dd155a78fff263adf0cfc))

## v0.4.1 (2023-03-13)

### Fix

* fix: random as 0 on 32 bit arch (#9) ([`c9fa4f3`](https://github.com/bdraco/ulid-transform/commit/c9fa4f32c12eabea67da14d0c32d9a5ac65f2842))

## v0.4.0 (2023-03-01)

### Feature

* feat: add bytes_to_ulid (#8) ([`c9a57ef`](https://github.com/bdraco/ulid-transform/commit/c9a57ef2d68886d37e03dd9d884a51c35a5c1e12))

## v0.3.1 (2023-03-01)

### Chore

* chore: add timestamp test (#6) ([`404487d`](https://github.com/bdraco/ulid-transform/commit/404487dd5879f83c6df6ad230ca6670edaacaa40))

### Fix

* fix: encode timestamps correctly in cpp implementation (#7) ([`c7fedc3`](https://github.com/bdraco/ulid-transform/commit/c7fedc350bf9848dc38af362e33819fac4036a9e))

## v0.3.0 (2023-02-28)

### Feature

* feat: add examples (#5) ([`be30a13`](https://github.com/bdraco/ulid-transform/commit/be30a133b3a03b1e6704954cf0c59f4fb64d4b7c))

## v0.2.1 (2023-02-28)

### Fix

* fix: drop fast-ulid for cython (#4) ([`8d72d6b`](https://github.com/bdraco/ulid-transform/commit/8d72d6b58d306d722f096a5b3697d4365eae397d))

## v0.2.0 (2023-02-28)

### Feature

* feat: enable cython builds (#3) ([`154bf0c`](https://github.com/bdraco/ulid-transform/commit/154bf0c8d02591508b87c2c154ba877da2aa8f97))

## v0.1.0 (2023-02-28)

### Chore

* chore: initial commit ([`61fc260`](https://github.com/bdraco/ulid-transform/commit/61fc2606750f879ba7fb69ba3bdd371c5bcac2e8))

### Feature

* feat: init repo (#1) ([`0ef9511`](https://github.com/bdraco/ulid-transform/commit/0ef95113cd638617de16be44909b228d0df5f092))

### Fix

* fix: remove html file (#2) ([`c1a5cf4`](https://github.com/bdraco/ulid-transform/commit/c1a5cf4a4a8c5a2c8ba1663b9132d612fe47570d))
